LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY FullStep IS
	PORT ( clk        : IN 	std_logic;
		   Enable : IN  std_logic;
		   R1_L0      : IN 	std_logic;
		   Output    : OUT std_logic_vector(3 downto 0)
         );
END FullStep ;

ARCHITECTURE FullStep_a OF FullStep IS
BEGIN
PROCESS (clk)
VARIABLE Counter : integer range 0 to 3 := 0;
Variable M0Out : std_logic_vector(3 downto 0);
Variable M1Out : std_logic_vector(3 downto 0);
Variable M2Out : std_logic_vector(3 downto 0);
Variable M3Out : std_logic_vector(3 downto 0);
BEGIN
if Enable ='1' then
	Counter := 0;
	Output <= "0000";
else
	if clk'event and clk = '1' then
		if R1_L0 = '0'then
			M0Out:="1000";
			M1Out:="0100";
			M2Out:="0010";
			M3Out:="0001";
		else
			M0Out:="1000";
			M1Out:="0001";
			M2Out:="0010";
			M3Out:="0100";
		end if;
		case Counter is
			when 0 => Output<=M0Out;
			when 1 => Output<=M1Out;
			when 2 => Output<=M2Out;
			when 3 => Output<=M3Out;
		end case;
		Counter:=Counter+1;
	end if;
end if;
END PROCESS;
END FullStep_a ;

