LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY HalfStep IS
	PORT ( clk      : IN 	std_logic;
		   Enable 	: IN  std_logic;
		   R1_L0    : IN 	std_logic;
		   Output	: OUT std_logic_vector(3 downto 0)
         );
END HalfStep ;

ARCHITECTURE HalfStep_a OF HalfStep IS
BEGIN
PROCESS (clk)
VARIABLE Counter : integer range 0 to 7 := 0;
Variable M0Out : std_logic_vector(3 downto 0);
Variable M1Out : std_logic_vector(3 downto 0);
Variable M2Out : std_logic_vector(3 downto 0);
Variable M3Out : std_logic_vector(3 downto 0);
Variable M4Out : std_logic_vector(3 downto 0);
Variable M5Out : std_logic_vector(3 downto 0);
Variable M6Out : std_logic_vector(3 downto 0);
Variable M7Out : std_logic_vector(3 downto 0);


BEGIN
if Enable ='1' then
	Counter := 0;
	Output<="0000";
elsif clk='1' and clk'event then
	if R1_L0 = '0'then		
			
	    M0Out:="1000";
    	M1Out:="1100";
	    M2Out:="0100";
	    M3Out:="0110";
	    M4Out:="0010";
	    M5Out:="0011";
	    M6Out:="0001";
	    M7Out:="1001";

	else
	    M0Out:="1001";
	    M1Out:="0001";
	    M2Out:="0011";
	    M3Out:="0010";
	    M4Out:="0110";
	    M5Out:="0100";
    	M6Out:="1100";
	    M7Out:="1000";
	end if;
	case Counter is
    	when 0 => Output<=M0Out;
	    when 1 => Output<=M1Out;
    	when 2 => Output<=M2Out;
	    when 3 => Output<=M3Out;
	    when 4 => Output<=M4Out;
	    when 5 => Output<=M5Out;
	    when 6 => Output<=M6Out;
	    when 7 => Output<=M7Out;
	end case;
    Counter:=Counter+1;
end if;
END PROCESS;
END HalfStep_a ;

