library ieee;
use ieee.std_logic_1164.all;

entity decode_ctl_cmd is
	port 
	(
		data_in	: in	integer range 0 to 15;
		on_off : out std_logic;
		direction : out std_logic;
		speed_sel : out std_logic;
		clk		:	in	bit;		
		mode : out integer range 0 to 7		
	);
end entity;

architecture rtl of decode_ctl_cmd is
begin

	process (data_in,clk)
	begin
	if clk'event and clk = '1' then
		case data_in is
			when 0 =>	-- On
				on_off <= '0';				
				mode <= 1;				
				speed_sel <= '0';
				direction <= '1';

			when 1 =>	-- Off
				on_off <= '1';					
			when 4 =>	-- TR
				direction <= '1';
			when 5 =>	-- TL
				direction <= '0';
			when 8 =>	-- SP1
				speed_sel <= '0';
			when 9 =>	-- SP2
				speed_sel <= '1';
			when 12 =>	-- P1
				mode <= 1;						
			when 13 =>	-- P2
				mode <= 2;		
			when 14 =>	--HP
				mode <= 4;	
			when others =>			

		end case;

	end if;
	end process;

end rtl;
