library ieee;
use ieee.std_logic_1164.all;

entity scankey4x4 is
port(
	clk : in std_logic;
	colum : in std_logic_vector(3 downto 0);
	row : out std_logic_vector(3 downto 0);
	data : out integer range 0 to 15;
	data_tig : out std_logic
	);
end scankey4x4;

Architecture RTL of scankey4x4 is
signal row_data : std_logic_vector(3 downto 0);
begin
	row <= row_data;
	Process(clk)
	variable count : integer range 0 to 3 ;
	begin
	  if (clk'EVENT) and (clk = '1') then
	    if count <= 3 then
		  count := count + 1;
		else
		  count := 0;
		end if;
		
		case count is
		  when 0 =>
			row_data <= "1110";   
		  when 1 =>
			row_data <= "1101";			    
		  when 2 =>
			row_data <= "1011";
		  when 3 =>
			row_data <= "0111";
		end case;
	  end if;
	end Process;

	process(clk,colum)
    begin
	  if (clk'EVENT) and (clk = '1') then
		case row_data is
		  when "1110" =>
			case colum is
			  when "1110" => data <= 0; data_tig <='1'; --0
			  when "1101" => data <= 1; data_tig <='1'; --1
			  when "1011" => data <= 2; data_tig <='1'; --2
			  when "0111" => data <= 3; data_tig <='1'; --3
			  when others => data_tig <= '0';
			end case;
			
		  when "1101" =>
			case colum is
			  when "1110" => data <= 4; data_tig <= '1'; --4
			  when "1101" => data <= 5; data_tig <= '1'; --5
			  when "1011" => data <= 6; data_tig <= '1'; --6
			  when "0111" => data <= 7; data_tig <= '1'; --7
			  when others => data_tig <= '0';
			end case;

		  when "1011" =>
			case colum is
			  when "1110" => data <= 8; data_tig <= '1'; --8
			  when "1101" => data <= 9; data_tig <= '1'; --9
			  when "1011" => data <= 10; data_tig <= '1'; --10
			  when "0111" => data <= 11; data_tig <= '1'; --11
			  when others => data_tig <= '0';
			end case;

		  when "0111" =>
			case colum is
			  when "1110" => data <= 12; data_tig <= '1'; --12
			  when "1101" => data <= 13; data_tig <= '1'; --13
			  when "1011" => data <= 14; data_tig <= '1'; --14		
			  when "0111" => data <= 15; data_tig <= '1'; --15
			  when others => data_tig <= '0';
			end case;
		  
		  when others => 
			data_tig <= '0';
		end case;
	  end if;
	end process;

end RTL;
